program CopyTbl;
{$R Dialog}
uses WinProcs,Messages,commctrl,BDE,ShlObj;

const
  ComboID  =1000;
  EditID   =1001;
  DirBtnID =1002;
  LabelID  =1003;
  ProgrID  =1004;
  CopyBtnID=1;
  PackBtnID=1005;
  ExitBtnID=2;

function DirectoryExists(const Name: string): Boolean;
var
  Code: Integer;
begin
  Code := GetFileAttributes(PChar(Name));
  Result := (Code <> -1) and (FILE_ATTRIBUTE_DIRECTORY and Code <> 0);
end;

//-----     
function MyExtrFilePath(const S:string):string;
var
  i:integer;
begin
  i:=Length(S);
  Result:='';
  if (S[i]<>'\')and(S[i]<>':') then
    repeat
      dec(i);
      if i=0 then exit;
    until (S[i]='\')or(S[i]=':');
  Result:=Copy(S,1,i);
end;

//---------------
function SelectDirectory(const Caption:string;const Root:WideString;var Dir:string):Boolean;
var
  BrowInf    : BROWSEINFO;
  Buffer     : array[0..255]of char;
  RootItemIDList,ItemID : PItemIDList;
  IDesktopFolder        : IShellFolder;
  Eaten, Flags          : LongWord;
begin
  Dir:='';
  FillChar(BrowInf,SizeOf(BROWSEINFO),0);

  RootItemIDList:=nil;

  if Root<>'' then
  begin
    SHGetDesktopFolder(IDesktopFolder);
    IDesktopFolder.ParseDisplayName(0,nil,@Root[1],Eaten,RootItemIDList,Flags);
  end;

  with BrowInf do
  begin
    hwndOwner := 0;
    pidlRoot := RootItemIDList;
    pszDisplayName := Buffer;
    lpszTitle := PChar(Caption);
    ulFlags := BIF_RETURNONLYFSDIRS;
    lpfn:=nil;

  end;
  ItemID:=ShBrowseForFolder(BrowInf);
  Result:=ItemID<>nil;
  if Result then
  begin
    ShGetPathFromIDList(ItemID,Buffer);
    Dir:=Buffer;
  end;
end;
//---------------

procedure fDbiOpenDatabase(var hDb: hDbiDb; Alias: String);
begin
  DbiOpenDatabase(PChar(Alias),nil,dbiReadWrite,dbiOpenShared,
    nil,0,nil,nil,hdb);
end;

procedure fDbiCopyTable(hTmpDb: hDbiDb; SrcTableName: string; DestName: string);
begin
  DbiCopyTable(hTmpDb,True,PChar(SrcTableName),nil, PChar(DestName));
end;

procedure PackTable(hCur:hDBICur;TName:string);
var
  Props: CURProps;
  hDb: hDBIDb;
  TableDesc: CRTblDesc;
begin
  // Get the table properties to determine table type...
  DbiGetCursorProps(hCur,Props);
  // Blank out the structure...
  ZeroMemory(@TableDesc, sizeof(TableDesc));
  // Get the database handle from the table's cursor handle...
  DbiGetObjFromObj(hDBIObj(hCur), objDATABASE, hDBIObj(hDb));
  // Put the table name in the table descriptor...
  lstrcpy(TableDesc.szTblName,PChar(TName));
  // Put the table type in the table descriptor...
  lstrcpy(TableDesc.szTblType, Props.szTableType);
  // Set the Pack option in the table descriptor to TRUE...
  TableDesc.bPack := True;
  // Close the table so the restructure can complete...
  DbiCloseCursor(hCur);
  // Call DbiDoRestructure...
  DbiDoRestructure(hDb, 1, @TableDesc, nil, nil, nil, False);
end;

function DlgProc(Dlg:HWnd;Msg,WParam,LParam:Longint):Bool; export; stdcall;
var
  p:array[0..255]of char;
  TmpHandle:THandle;
  TmpCursor: hDbiCur;
  Database: DBDesc;
  rslt: DbiResult;
  hDB: hDBIDB;
  hCur,hCur2: hDBICur;
  ListDesc:TBLBaseDesc;
  TabCount,Nom:integer;
  DirName:string;
begin
  Result:=True;
  case Msg of
    wm_InitDialog:
      begin
        SendMessage(Dlg,WM_SETICON,ICON_BIG,LoadIcon(HInstance,'MAINICON'));

        TmpHandle:=GetDlgItem(Dlg,ProgrID);

        SendMessage(TmpHandle,PBM_DELTAPOS,1,0);
        SendMessage(TmpHandle,PBM_SETSTEP,1,0);   // 
        SendMessage(TmpHandle,PBM_SETPOS,0,0);    // 


        TmpHandle:=GetDlgItem(Dlg,ComboID);

        DirName:=MyExtrFilePath(ParamStr(0))+'CopyData';
        SetWindowText(GetDlgItem(Dlg,EditID),PChar(DirName));

        SetWindowText(GetDlgItem(Dlg,LabelID),'');

//    

        DbiOpenDatabaseList(TmpCursor);
        repeat
          rslt:=DbiGetNextRecord(TmpCursor,dbiNOLOCK,@Database,nil);
          if rslt<>DBIERR_EOF then
            if Database.szDbType='STANDARD' then
              SendMessage(TmpHandle,CB_ADDSTRING,0,LongInt(@Database.szName[0]));
        until rslt<>DBIERR_NONE;
        DbiCloseCursor(TmpCursor);
        //  ItemIndex
        if SendMessage(TmpHandle,CB_GETCOUNT,0,0)>0 then
          SendMessage(TmpHandle,CB_SETCURSEL,0,0);

        if ParamCount=2 then
        begin
          SetWindowText(GetDlgItem(Dlg,EditID),PChar(ParamStr(2)));
          SetWindowText(TmpHandle,PChar(ParamStr(1)));
          Nom:=SendMessage(TmpHandle,CB_FINDSTRING,0,LongInt(PChar(ParamStr(1))));
          if Nom<>CB_ERR then SendMessage(TmpHandle,CB_SETCURSEL,Nom,0);
        end;

      end;
    wm_Command:
      case LoWord(WParam) of
        CopyBtnID:
          begin

            GetWindowText(GetDlgItem(Dlg,EditID),p,255);
            DirName:=p;
            if not DirectoryExists(DirName) then
            if not CreateDirectory(PChar(DirName),nil) then
            begin
              MessageBox(Dlg,'  ...','',0);
              exit;
            end;

            GetWindowText(GetDlgItem(Dlg,ComboID),p,255);
            //   

            fDbiOpenDatabase(hDB,p);

            TabCount:=0;
            DbiOpenTableList(hDB,False,False,'*.DB',hCur);
            while DbiGetNextRecord(hCur,dbiNOLOCK,nil,nil)=dbiErr_None do
              inc(TabCount);

            TmpHandle:=GetDlgItem(Dlg,ProgrID);

            SendMessage(TmpHandle,PBM_SETPOS,0,0);    // 
            SendMessage(TmpHandle,PBM_SETRANGE,0,MAKELPARAM(0,TabCount));

            DbiOpenTableList(hDB,False,False,'*.DB',hCur);
            while DbiGetNextRecord(hCur,dbiNOLOCK,@ListDesc,nil)=dbiErr_None do
            begin
              SetWindowText(GetDlgItem(Dlg,LabelID),PChar(': '+ListDesc.szName+'.db'));

              fDbiCopyTable(hDB,ListDesc.szName+'.db',
                            DirName+'\'+ListDesc.szName+'.db');
              SendMessage(TmpHandle,PBM_STEPIT,1,0)
            end;
            DbiCloseDatabase(hDB);            //   

            SendMessage(TmpHandle,PBM_SETPOS,0,0);    // 
            SetWindowText(GetDlgItem(Dlg,LabelID),'  ...');

          end;

        DirBtnID:
          begin
            if SelectDirectory(' ','',DirName) then
              SetWindowText(GetDlgItem(Dlg,EditID),PChar(DirName));
          end;

        PackBtnID:
          begin

            GetWindowText(GetDlgItem(Dlg,ComboID),p,255);
            fDbiOpenDatabase(hDB,p);

            TabCount:=0;
            DbiOpenTableList(hDB,False,False,'*.DB',hCur);
            while DbiGetNextRecord(hCur,dbiNOLOCK,nil,nil)=dbiErr_None do
              inc(TabCount);

            TmpHandle:=GetDlgItem(Dlg,ProgrID);

            SendMessage(TmpHandle,PBM_SETPOS,0,0);    // 
            SendMessage(TmpHandle,PBM_SETRANGE,0,MAKELPARAM(0,TabCount));

            DbiOpenTableList(hDB,False,False,'*.DB',hCur);
            while DbiGetNextRecord(hCur,dbiNOLOCK,@ListDesc,nil)=dbiErr_None do
            begin
              SetWindowText(GetDlgItem(Dlg,LabelID),PChar(': '+ListDesc.szName+'.db'));
              //  
              DbiOpenTable(
                hDB,                         //   
                ListDesc.szName,             //  
                PChar(szParadox),            //   (   )
                Nil,                         //   ()
                Nil,                         // IndexTagName -   dBASE
                0,                           // 0 -   
                dbiReadWrite,                //   
                dbiOPENEXCL,                 //   
                xltField,                    //   
                False,                       //    
                Nil,                         //  
                hCur2);                      //   

              PackTable(hCur2,ListDesc.szName+'.db');
              SendMessage(TmpHandle,PBM_STEPIT,1,0)
            end;

            DbiCloseDatabase(hDB);            //   

            SendMessage(TmpHandle,PBM_SETPOS,0,0);    // 
            SetWindowText(GetDlgItem(Dlg,LabelID),'  ...');
          end;


        2 :EndDialog(Dlg,1);
      end;

    wm_Close:DestroyWindow(Dlg);
    wm_Destroy:PostQuitMessage(0);
    Else Result:=False;
  end;
end;
var
  H:THandle;
begin
  H:=LoadLibrary('comctl32.dll'); //     Progress Bar
  DbiInit(Nil);                   //   BDE
  DialogBox(hInstance,'MAIN',0,@DlgProc);
  DbiExit;                        //     BDE
  FreeLibrary(H);
end.
